import numpy as np

def Euler(f,T,y0,h):
    # Solves the initial value problem y'=f(t,y), y(0)=y0 up 
    # to time T using the explicit Euler method and constant 
    # step size h.

    
    N = round((T-0)/h)          # number of steps
    t = np.zeros((N+1,1))       # time points
    y = np.zeros((N+1,1))       # solution vector
    y[0] = y0                   # initial condition
    
    def eulerstep(f,t,y,h):
        return y + h*f(t,y)
    
    for n in range(1,N+1):
    # Calculate approximation using Euler method
        y[n] = eulerstep(f,t[n-1],y[n-1],h)
        t[n] = t[n-1] + h
        
    return y,t